import java.util.Properties;

import javax.naming.Context;
import javax.naming.InitialContext;

import org.jboss.logging.Logger;

import com.redhat.example.ejb.RemoteEJB;

public class TestMain {
    private static final Logger log = Logger.getLogger(TestMain.class);
    
    // FIXME
    public static String providerIpPort = "127.0.0.1:4447";
    public static String principal = "jboss";
    public static String credential = "RedHat1!";

    private static final String JNDI_NAME = "/case-01545389-1.0.0/RemoteEJBBean!com.redhat.example.ejb.RemoteEJB";

    public static void main(String[] args) throws Exception {
        log.info("******** START******** ");

        Context rootContext1 = null;
        Context ejbContext1 = null;
        try {

            rootContext1 = new InitialContext(createUniqueNamedProperties());

            log.info("******** Looking up ejbContext ******** ");
            ejbContext1 = (Context) rootContext1.lookup("ejb:");
            log.info("******** Looked up ejbContext ******** ");

            log.info("******** Looking up remoteEjb ******** ");
            RemoteEJB ejb = (RemoteEJB) ejbContext1.lookup(JNDI_NAME);
            log.info("******** Looked up remoteEjb ******** ");

            log.info("******** Invoking EJB ******** ");
            ejb.execute("hoge");
            log.info("******** Invoked EJB ******** ");
            
        } catch (Exception e) {
            log.error("EXCEPTION! ", e);
        } finally {
            if (ejbContext1 != null) {
                log.info("******** CLOSING ejbContext ********");
                ejbContext1.close();
                log.info("******** CLOSED ejbContext ********");
            }
            if (rootContext1 != null) {
                log.info("******** CLOSING rootContext ********");
                rootContext1.close();
                log.info("******** CLOSED rootContext ********");
            }
        }
    }

    private static Properties createUniqueNamedProperties() {
        Properties jndiProperties = new Properties();
        String[] hostPort = providerIpPort.split(":");

        jndiProperties.put(Context.URL_PKG_PREFIXES,
                "org.jboss.ejb.client.naming");
        jndiProperties.put("org.jboss.ejb.client.scoped.context", "true");

        jndiProperties
                .put("remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED",
                        "false");
        jndiProperties.put("remote.connections", "default");
        jndiProperties.put("remote.connection.default.host", hostPort[0]);
        jndiProperties.put("remote.connection.default.port", hostPort[1]);
        jndiProperties.put("remote.connection.default.username", principal);
        jndiProperties.put("remote.connection.default.password", credential);
        jndiProperties
                .put("remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS",
                        "false");
        return jndiProperties;
    }

}
